/* isdnact.c
ISDN Examination and Action
Version 1.01.0 Beta
Author: David Cutting (dcutting@magicboxes.net)
Copyright 2000 MagicBoxes http://www.magicboxes.net/
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main (void)
{
FILE *fileptr;
int line0=0,line1=0,s0=0,s1=0;
char l0[128],l1[128];
printf("isdnexam 0.01 David Cutting (dcutting@magicboxes.net)\n");
system("/usr/sbin/isdnctrl status ippp0 > /isdn/isdnstate");
system("/usr/sbin/isdnctrl status ippp1 >> /isdn/isdnstate");
fileptr=fopen("/isdn/isdnstate","r");
fgets(l0,127,fileptr);
fgets(l1,127,fileptr);
fclose(fileptr);
line0=strstr(l0,"connected to");
line1=strstr(l1,"connected to");
if (line0!=0)
	s0=2;
else
	{
	line0=strstr(l0,"connected from");
	if (line0!=0)
		s0=1;
	}
if (line1!=0)
	s1=2;
else
	{
	line1=strstr(l1,"connected from");
	if (line1!=0)
		s1=1;
	}

switch (s0)
	{
	case 0:
	printf("64k Disconnected\n");
	system("/isdn/isdnres");
	system("/usr/sbin/isdnctrl dial ippp0");
	system("echo \"Started 64k at \"$(date) > /isdn/connect");
	break;
	case 1:
	printf("64k Connecting\n");
	break;
	case 2:
	printf("64k Connected\n");
	break;
	default:
	printf("Error! Unable to determine state of ippp0\n");
	break;
	}

switch (s1)
	{
	case 0:
	printf("128k Disconnected\n");
	// if line0 is up then dial line1
	if (s0==2)
		{
		system("/usr/sbin/isdnctrl dial ippp1");
		system("echo \"128k trigger at \"$(date) >> /isdn/connect");
		}
	break;
	case 1:
	printf("128k Connecting\n");
	break;
	case 2:
	printf("128k Connected\n");
	break;
	default:
	printf("Error! Unable to determine state of ippp1\n");
	}
return 1;
}
